/*
 *  Kiss streaming server 
 *
 *  Copyright (C) 2003-2004 Thibault Lamy (xoubir@sourceforge.net)
 *                2003-2004 Jarl van Katwijk (bstard@sourceforge.net)
 *                2005      Erik Kunze (eku@sourceforge.net)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: cmd_list.c,v 1.13 2005/08/22 09:17:17 eku Exp $
 */

#include <sys/types.h>
#include <string.h>
#include "dp500.h"
#include "logging.h"
#include "clients.h"
#include "files_tools.h"
#include "common_menu.h"
#include "cmds.h"


void
cmd_list(char *args, t_client * clt, t_dp500 * dp500)
{
  char *p1, *p2;
  char *listtype, *path, *menu;

  p1 = strchr(args, '|');
  p2 = strrchr(args, '|');
  if (p1 == NULL || p2 == NULL)
    {
      do_log2(2, clt->fd, "%s: invalid request '%s'\n", __func__, args);
      return;
    }
  *(p1 - 1) = '\0';
  *p2 = '\0';

  listtype = args;
  path = p1 + 1;
  menu = strstr(path, MENU_PREFIX);

  do_log2(4, clt->fd, "%s: list '%s' path '%s'\n", __func__, listtype, path);

  /* Check if we are on a virtual dir */
  if (strcmp(path + strlen(path) - strlen(PATH_DP500_MENU), PATH_DP500_MENU)
      == 0)
    {
      send_common_menu_items(clt);
    }
  else if (menu != NULL)
    {
      exec_common_menu_item(menu + strlen(MENU_PREFIX), clt);
    }
  /* Then look at list type */
  else if (strcmp(listtype, "AUDIO") == 0)
    {
      build_file_list_audio(path, clt);
    }
  else if (strcmp(listtype, "VIDEO") == 0)
    {
      build_file_list_video(path, clt);
    }
  else if (strcmp(listtype, "PICTURE") == 0)
    {
      build_file_list_images(path, clt);
    }
  else
    {
      do_log(1, "%s: unknown list '%s'\n", __func__, listtype);
    }
}

/* EOF */
