/*
 *  Kiss streaming server 
 *
 *  Copyright (C) 2003-2004 Thibault Lamy (xoubir@sourceforge.net)
 *                2003-2004 Jarl van Katwijk (bstard@sourceforge.net)
 *                2005      Erik Kunze (eku@sourceforge.net)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: common_menu.c,v 1.5 2005/08/17 07:51:13 eku Exp $
 */

#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "dp500.h"
#include "logging.h"
#ifdef HAVE_RECENTLY_PLAYLIST
#include "playlists.h"
#endif
#include "send_tools.h"
#include "kill_server.h"
#include "common_menu.h"


int
send_common_menu_dir(t_client * clt)
{
  send_dir("-----------------  SERVER MENU  ------------------",
	   PATH_DP500_MENU, clt);
  return 1;
}

int
send_common_menu_items(t_client * clt)
{
  char str[64];
  char str2[64];

#ifdef HAVE_RECENTLY_PLAYLIST
  /* TODO: move RecentlyPlayed to here. */
  snprintf(str, sizeof(str), "%s%s",
	   MENU_PREFIX, RECENTLY_PLAYLIST_REALNAME);
  snprintf(str2, sizeof(str2), "%s", RECENTLY_PLAYLIST_KISSNAME);
  send_dir(str2, str, clt);
#endif

  snprintf(str, sizeof(str), "%sEXIT", MENU_PREFIX);
  snprintf(str2, sizeof(str2), "[]  Exit DP500Serv");
  send_dir(str2, str, clt);
  do_log2(4, clt->fd, "SEND Common Menu '%s,%s'\n", str2, str);

  snprintf(str, sizeof(str), "%sREBOOT", MENU_PREFIX);
  snprintf(str2,sizeof(str2), "[]  Reboot the DP500Serv host");
  send_dir(str2, str, clt);
  do_log2(4, clt->fd, "SEND Common Menu '%s,%s'\n", str2, str);

  snprintf(str, sizeof(str), "%sHALT", MENU_PREFIX);
  snprintf(str2, sizeof(str2), "[]  Shutdown the DP500Serv host");
  send_dir(str2, str, clt);
  do_log2(4, clt->fd, "SEND Common Menu '%s,%s'\n", str2, str);

  return 1;
}

int
exec_common_menu_item(const char *cmd, t_client * clt)
{
  do_log2(4, clt->fd, "EXEC Comon Menu '%s'\n", cmd);

  if (strncmp(cmd, "EXIT", 4) == 0)
    {
      do_log(1, "DP500Serv exit requested by menu");
      kill_server(0);
    }
  else if (strncmp(cmd, "REBOOT", 6) == 0)
    {
      system(gl_dp500->reboot_cmd);
    }
  else if (strncmp(cmd, "HALT", 4) == 0)
    {
      system(gl_dp500->halt_cmd);
    }
  return 1;
}

/* EOF */
