/*
 *  Kiss streaming server 
 *
 *  Copyright (C) 2003-2004 Thibault Lamy (xoubir@sourceforge.net)
 *                2003-2004 Jarl van Katwijk (bstard@sourceforge.net)
 *                2005      Erik Kunze (eku@sourceforge.net)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: dvd_tools.h,v 1.4 2005/08/14 18:26:23 eku Exp $
 */

#ifdef DVDSUPPORT

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <stdlib.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "dp500.h"
#include "logging.h"
/* libdvdread includes */
#include <dvdread/dvd_reader.h>
#include <dvdread/ifo_types.h>
#include <dvdread/ifo_read.h>
#include <dvdread/nav_read.h>
#include <dvdread/nav_print.h>

#define FALSE 0
#define TRUE 1
#define RANGE 400	/* Max amount of 'titles' dp500serv can handle */


typedef struct _cell_t
{
  int cell;
  int angle;
  int pc;
} cell_t;

/* TODO: all config in one struct seems not to be perfect... */
typedef struct _dvd_config
{
  dvd_reader_t *DVDhandle;
  int DVD_TitleSets;
  int DVD_Total_Titles;
  int DVD_Total_ChapterSequences;
  int VTS_Titles[RANGE];
  int VT_Chapters[RANGE];
  int VT_Angles[RANGE];
  double VTS_Aspects[RANGE];
  int VT_is_DVDtitle[RANGE];
  int CS[RANGE];
  int CS_current;
  int VT_belongs_to_VTS[RANGE];
  int CS_belongs_to_VT[RANGE];
  int CS_starts_at_Chapter[RANGE];
  int CS_Chapters[RANGE];
  int VT_is_Title_of_VTS[RANGE];
} dvd_config;

extern int dvd_to_mpeg_read(uint position, int len, t_client * clt);
extern char *dvd_to_mpeg_start(char *path);
extern int detect_DVD_titles(char *_path, t_client * clt);

#endif

/* EOF */
