/*
 *  Kiss streaming server 
 *
 *  Copyright (C) 2003-2004 Thibault Lamy (xoubir@sourceforge.net)
 *                2003-2004 Jarl van Katwijk (bstard@sourceforge.net)
 *                2005      Erik Kunze (eku@sourceforge.net)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: exec_cmd.c,v 1.6 2005/08/14 18:26:23 eku Exp $
 */

#include <sys/types.h>
#include <string.h>
#include "dp500.h"
#include "logging.h"
#include "cmd_tab.h"
#include "cmd_tab.h"
#include "fix_line.h"
#include "exec_cmd.h"


static t_functab *
find_command(const char *cmd)
{
  int i;

  for (i = 0; ircd_tab[i].cmd != 0; i++)
    {
      if (strcasecmp(cmd, ircd_tab[i].cmd) == 0)
	goto out;
    }
  do_log(1, "%s: unknown command '%s'\n", __func__, cmd);

out:
  return &ircd_tab[i];
}

void
exec_cmd(char *line, t_client * clt, t_dp500 * dp500)
{
  char *params;
  t_functab *func;

  params = fix_line(line);
  func = find_command(line);
  func->fnct(params, clt, dp500);
}

/* EOF */
