/*
 *  Kiss streaming server 
 *
 *  Copyright (C) 2003-2004 Thibault Lamy (xoubir@sourceforge.net)
 *                2003-2004 Jarl van Katwijk (bstard@sourceforge.net)
 *                2005      Erik Kunze (eku@sourceforge.net)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: send_tools.c,v 1.6 2005/08/18 06:39:55 eku Exp $
 */

#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include "dp500.h"
#include "logging.h"
#include "files_tools.h"
#include "send_tools.h"


int
send_dir(const char *dirkiss, const char *dirpath, t_client * clt)
{
  int fd = clt->fd;

  do_log2(4, fd, "%s: '%s| %s|1|'\n", __func__, dirkiss, dirpath);

  write(fd, dirkiss, strlen(dirkiss));
  write(fd, "| ", 2);
  write(fd, dirpath, strlen(dirpath));
  write(fd, "|1|\n", 4);
  return 1;
}

int
send_item(const char *itemkiss, const char *itempath, const char *itemname,
	  t_client * clt)
{
  int fd = clt->fd;

  do_log2(4, fd, "%s: '%s| %s%s%s|0|'\n", __func__, itemkiss,
	  itempath ? itempath : "", itempath ? "\\" : "", itemname);

#if 0
  source_tracker_add(itemkiss, itempath, itemname);
#endif

  write(fd, itemkiss, strlen(itemkiss));
  write(fd, "| ", 2);
  if (itempath)
    {
      write(fd, itempath, strlen(itempath));
      write(fd, "\\", 1);
    }
  write(fd, itemname, strlen(itemname));
  write(fd, "|0|\n", 4);
  return 1;
}

/* EOF */
